# -*- coding: utf-8 -*-
from setuphelpers import *
import json


def update_package():
    # Compile
    if isdir(r"c:\build"):
        remove_tree(r"c:\build")
    run(r'"C:\Program Files\Git\bin\git.exe" clone  https://gitea.ad.tranquil.it/tis-internal-tools/tis-rsat.git c:\build')     # todo
    run(r'"C:\Program Files\Git\bin\git.exe" -C c:\build submodule update --progress --init -- "submodules/mORMot2"')
    run(r'"C:\Program Files\Git\bin\git.exe" -C c:\build submodule update --progress --init -- "submodules/pltis_uicomponents"')
    run(r'"C:\Program Files\Git\bin\git.exe" -C c:\build submodule update --progress --init -- "submodules/pltis_tsmbios"')
    run(r'"C:\Program Files\Git\bin\git.exe" -C c:\build submodule update --progress --init -- "submodules/pltis_utils"')
    run(r'"C:\Program Files\Git\bin\git.exe" -C c:\build submodule update --progress --init -- "submodules/pltis_virtualtrees"')
    run(r'"C:\Program Files\Git\bin\git.exe" -C c:\build submodule update --progress --init -- "submodules/metadarkstyle"')

    try:
        run(r'C:\lazarus_2_2\lazarus\lazbuild.exe  --build-ide="Normal IDE"')
    except:
        pass

    wget('https://synopse.info/files/mormot2static.7z','mormot2static.7z')
    run(r'"c:\Program Files\7-Zip\7z.exe" x -y mormot2static.7z -ostatic')
    remove_tree(r'c:\build\submodules\mORMot2\static')
    os.rename('static',r'c:\build\submodules\mORMot2\static')
    remove_file('mormot2static.7z')
    run(r'C:\lazarus_2_2\lazarus\lazbuild.exe --add-package-link c:\build\submodules\mORMot2\packages\lazarus\mormot2.lpk')
    run(r'C:\lazarus_2_2\lazarus\lazbuild.exe --add-package-link c:\build\submodules\pltis_uicomponents\pack\pltis_uicomponents.lpk')
    run(r'C:\lazarus_2_2\lazarus\lazbuild.exe --add-package-link c:\build\submodules\pltis_tsmbios\Packages\tsmbios.lpk')
    run(r'C:\lazarus_2_2\lazarus\lazbuild.exe --add-package-link c:\build\submodules\pltis_utils\pltis_utils.lpk')
    run(r'C:\lazarus_2_2\lazarus\lazbuild.exe --add-package c:\build\submodules\pltis_virtualtrees\virtualtreeview_package.lpk')
    run(r'C:\lazarus_2_2\lazarus\lazbuild.exe --add-package c:\build\submodules\metadarkstyle\metadarkstyle.lpk')
    run(r'C:\lazarus_2_2\lazarus\lazbuild.exe --add-package c:\build\submodules\metadarkstyle\metadarkstyledsgn.lpk')

    run(r'C:\lazarus_2_2\lazarus\lazbuild.exe --build-mode=win64 c:\build\src\tisrsat.lpi')

    #WAPT Package prepare
    filecopyto(r'c:\build\bin\win64\tisrsat.exe','RsatConsole.exe')

    version = "0.0.%s" % run(r'"C:\Program Files\Git\bin\git.exe" -C "c:\build" rev-list --count main').strip()

    control.set_software_version(version)
    control.save_control_to_wapt()
